var Global_DP_GameEntry = {
    dir: 'res/game_entry/',
    balloon_name: ['hong', 'huang', 'zi'],
    layer: null,
    coin_box: null,
    scroll: null,
    entrys: null
};

var DP_GameEntryScrollView = ccui.ScrollView.extend({
    isScroll: false,
    firstOnEnter: true,
    x1: 0,
    x2: 0,
    ctor: function () {
        this._super();
        this.setName('game entry scroll');
        Global_DP_GameEntry.scroll = this;

        this.setDirection(ccui.ScrollView.DIR_HORIZONTAL);
        this.setContentSize(cc.winSize.width, cc.winSize.height - Global_DP.sinkY);
        this.setScrollBarOpacity(0);
        // this.setBounceEnabled(false);
        // this.stopAutoScroll();
        this.setIsScroll();

        this.addBG();
        this.addSights();
        this.addTicketOffice();
        this.addEntry();
        this.addRole();
        this.addBalloon();
        this.addBalloonHot();

        // this.setAllChildrenOffsetX(-cc.winSize.width);

    },
    onEnter: function () {
        this._super();
        if (this.firstOnEnter) {
            this.firstOnEnter = false;
            this.setTouchEnabled(false);
            this.pauseEntry();
            ddSound.stopAll();
            ddSound.playEffect('entry__buy_ticket');
        } else {
            this.setTouchEnabled(true);
            this.resumeEntry();
            ddSound.stopAll();
        }
    },
    setAllChildrenOffsetX: function () {
        var offsetX = -cc.winSize.width;
        var children = this.getChildren();
        var layer = Global_DP_GameEntry.layer;
        for (var i = 0; i < children.length; ++i) {
            children[i].x += offsetX;
        }

        this.getInnerContainer().width += offsetX;
        this.jumpToLeft();
        this.setTouchEnabled(true);
        this.resumeEntry();
        layer.addMoveBtn();
        // zLog('hPercent : ', this.getScrolledPercentHorizontal());
        // var newSize = cc.size(size.width + offsetX, size.height);
        // this.setInnerContainerSize(this.getInnerContainerSize().width + offsetX, this.getInnerContainerSize().height);
    },
    addBG: function () {
        var size = cc.winSize;
        var x = 0;
        for (var i = 0; i < 4; i++) {
            var bg_hd = zNewSpriteCreate(Global_DP_GameEntry.dir, 'bg_hd_' + i, this);
            bg_hd.setAnchorPoint(0, 0);
            bg_hd.setPosition(x, 0);
            x += bg_hd.width;
        }
        this.setInnerContainerSize(cc.size(x, size.height - Global_DP.sinkY));
        // cc.log('add bg_hd ok');

        for (var i = 0; i < 5; ++i) {
            var bg_cloud = zNewSpriteCreate(Global_DP_GameEntry.dir, 'bg_cloud', this);
            bg_cloud.setPosition(size.width * (i + 1 / 2) + (Math.random() * 2 - 1) * size.width / 8, size.height);
            var speed = Math.random() * 10 + 50;
            bg_cloud.runAction(cc.sequence(
                cc.moveTo(((x + bg_cloud.width) - bg_cloud.x) / speed, x, bg_cloud.y),
                cc.place(0 - bg_cloud.width, bg_cloud.y),
                cc.moveTo((bg_cloud.x - (0 - bg_cloud.width)) / speed, bg_cloud.x, bg_cloud.y)
            ).repeat(65535 - 1));
        }

    },
    addSights: function () {
        /*var flowers_plants_L = zNewSpriteCreate(Global_DP_GameEntry.dir, 'flowers_plants', this);
        var flowers_plants_R = zNewSpriteCreate(Global_DP_GameEntry.dir, 'flowers_plants', this);
        flowers_plants_L.setPosition(0, 0);
        flowers_plants_R.setPosition(0, 0);
        zAddTouchLogPosEvent(flowers_plants_L, true);
        zAddTouchLogPosEvent(flowers_plants_R, true);*/
    },
    addTicketOffice: function () {
        var dir = Global_DP_GameEntry.dir;
        var ticket_door_1 = zNewSpriteCreate(dir, 'ticket_door_1', this);
        var ticket_door_0 = zNewSpriteCreate(dir, 'ticket_door_0', this);
        ticket_door_0.setLocalZOrder(10);
        ticket_door_0.setPosition(1403.95, 317.07 - 40);
        ticket_door_1.setPosition(1254.59, 433.19 - 40);
        // zAddTouchLogPosEvent(ticket_door_0);
        // zAddTouchLogPosEvent(ticket_door_1);

        var ticket_office = zNewSpineAnimationCreate(dir + 'ticket_office/', 'skeleton', this);
        ticket_office.setPosition(564.94, 308.14);
        ticket_office.setAnimation(0, 'maipiao', true);
        // zAddTouchLogPosEvent(ticket_office, true);
    },
    setIsScroll: function () {
        this.addTouchEventListener(function (sender, type) {
            if (type == 0) {
                sender.isScroll = false;
                sender.x1 = sender.getInnerContainerPosition().x;
            } else if (type == 1) {
                sender.x2 = sender.getInnerContainerPosition().x;
                if (Math.abs(sender.x2 - sender.x1) > 10) {
                    if (!sender.isScroll) {
                        sender.isScroll = true;
                        // zLog('isScroll : ', sender.isScroll);
                    }
                }
                sender.x1 = sender.x2;
                var layer = Global_DP_GameEntry.layer;
                var cPercent = sender.getScrolledPercentHorizontal();
                var move_btn_L = layer.move_btn_L;
                var move_btn_R = layer.move_btn_R;
                // zLog('cPercent : ', cPercent);
                if (cPercent <= 0) {
                    move_btn_L.setScale(0);
                } else if (cPercent > 0 && cPercent < 100) {
                    move_btn_L.setScale(1);
                    move_btn_R.setScale(1);
                } else if (cPercent >= 100) {
                    move_btn_R.setScale(0);
                }
            } else if (type == 2) {
                sender.isScroll = false;
            } else if (type == 3) {
                sender.isScroll = false;
            }
        }, this);
    },
    addEntry: function () {
        var self = this;
        var dir = Global_DP_GameEntry.dir;
        var entrys = [];
        var entryName = ['whack_a_mole', 'fishing', 'shooting', 'popcorn', 'coin_dozer', 'slot_machine', 'dining_room'];
        var entryPos = [
            cc.p(1864.78, 441.46), cc.p(2438.32, 462.52), cc.p(3107.24, 475.49), cc.p(3701.36, 423.80),
            cc.p(4507.90, 474.67), cc.p(5148.22, 480.57), cc.p(6081.28, 492.08)
        ];
        var entrySpinePos = [
            cc.p(215.71, 55.00), cc.p(252.96, 13.25), cc.p(297.76, 13.44), cc.p(246.84, 32.13),
            cc.p(254.91, 16.72), cc.p(266.91, 5.93), cc.p(370.04, 12.47)
        ];
        // var entryLockName = ['popcorn', 'coin_dozer', 'dining_room'];
        var entryLockName = [];
        var entryLockShadowPos = [cc.p(242.01, 262.61), cc.p(259.65, 250.85), cc.p(369.64, 398.21)];
        var listener = zNewEventListenerCreate(null, null, function (touch, target) {
            if (self.isScroll) {
                return;
            }
            // zLog('game : ', target.id.toString());
            self.pauseEntry();
            umengEvent('GAME_SRC', target.id.toString());
            self.intoEntry(target.id);
        }, null);
        listener.setSwallowTouches(false);
        for (var i = 0; i < entryName.length; ++i) {
            var idx = entryLockName.indexOf(entryName[i]);
            var entry = zNewSpriteCreate(dir, 'entry_' + entryName[i], this);
            var entrySpine = zNewSpineAnimationCreate(dir + entryName[i] + '/', 'skeleton', entry);
            entry.idx = i;
            entry.id = entryName[i];
            entry.setPosition(entryPos[i]);
            entry.setOpacity(0);
            entrySpine.setPosition(entrySpinePos[i]);
            entrySpine.setAnimation(0, 'rukou', true);
            zSetNodeEvent(listener.clone(), entry);

            // zLog(entryName[i]);
            // zAddTouchLogPosEvent(entry);
            // zAddTouchLogPosEvent(entrySpine, true);

            if (idx >= 0) {
                var entry_shadow = zNewSpriteCreate(dir, 'entry_' + entryName[i] + '_shadow', entry);
                var entry_lock = zNewSpriteCreate(dir, 'lock_entry', entry);
                entry_lock.setPosition(entry.width / 2, entry.height / 2);
                entry_shadow.setPosition(entryLockShadowPos[idx]);
                entry.lock = entry_lock;
                // zAddTouchLogPosEvent(entry_shadow);
            }
            entrys.push(entry);
        }
        Global_DP_GameEntry.entrys = entrys;
    },
    pauseEntry: function () {
        var entrys = Global_DP_GameEntry.entrys;
        entrys.forEach(function (item) {
            zPauseTargetEvent(item, true);
        })
    },
    resumeEntry: function () {
        var entrys = Global_DP_GameEntry.entrys;
        entrys.forEach(function (item) {
            zResumeTargetEvent(item, true);
        })
    },
    intoEntry: function (entryName) {
        var self = this;
        var entrys = Global_DP_GameEntry.entrys;
        var entry = entrys[0];

        if (entryName == 'whack_a_mole') {
            entry = entrys[0];
        } else if (entryName == 'fishing') {
            entry = entrys[1];
        } else if (entryName == 'shooting') {
            entry = entrys[2];
        } else if (entryName == 'popcorn') {
            entry = entrys[3];
        } else if (entryName == 'coin_dozer') {
            entry = entrys[4];
        } else if (entryName == 'slot_machine') {
            entry = entrys[5];
        } else if (entryName == 'dining_room') {
            entry = entrys[6];
        }
        entry.stopAllActions();
        entry.runAction(cc.sequence(
            cc.scaleTo(0.1, 1.1),
            cc.scaleTo(0.1, 0.9),
            cc.scaleTo(0.1, 1),
            cc.callFunc(function () {
                var ss = entryName.split('_');
                var scene = 'DP_';
                for (var i = 0; i < ss.length; ++i) {
                    ss[i] = ss[i].slice(0, 1).toUpperCase() + ss[i].slice(1);
                    scene += ss[i];
                }
                var coin_box = Global_DP_GameEntry.coin_box;
                var layer = Global_DP_GameEntry.layer;
                // zLog('coin_number : ', coin_box.getCoinNumber());
                if (entry.id == 'popcorn') {
                    if (coin_box.getCoinNumber() < 5) {
                        zAddCoinNoLayer(layer);
                        return;
                    } else if (coin_box.getCoinNumber() < 20) {
                        zAddCoinLackLayer(layer, 20);
                        return;
                    }
                    coin_box.setCoinNumber(coin_box.getCoinNumber() - 20);
                } else if (entry.id == 'dining_room') {
                    if (coin_box.getCoinNumber() < 5) {
                        zAddCoinNoLayer(layer);
                        return;
                    } else if (coin_box.getCoinNumber() < 30) {
                        zAddCoinLackLayer(layer, 30);
                        return;
                    }
                    coin_box.setCoinNumber(coin_box.getCoinNumber() - 30);
                } else if (entry.id != 'slot_machine') {
                    if (coin_box.getCoinNumber() < 5) {
                        zAddCoinNoLayer(layer);
                        return;
                    }
                }
                ddSound.stopAll();
                ddSound.playEffect('entry_' + entryName);
                eval('cc.director.pushScene(new ' + scene + 'Scene())');
            })
        ));
    },
    addRole: function () {
        var self = this;
        var dir = Global_DP_GameEntry.dir;
        var sw = cc.winSize.width;
        var roles = [];
        var roleName = ['dog', 'monkey', 'pig', 'rabbit'];
        // var roleName = ['monkey', 'pig'];
        var roleSpeed = [210, 220, 190, 230];
        var rolePos = [cc.p(800.94, 119.31), cc.p(548.59, 172.39), cc.p(353.70, 124.12), cc.p(1005.17, 95.03)];
        var roleZOrder = [2, 0, 1, 3];
        for (var i = 0; i < roleName.length; ++i) {
            var role = zNewSpineAnimationCreate(dir + 'role/' + roleName[i] + '/', 'skeleton', this);
            var role_shadow = zNewSpriteCreate(dir, 'role_shadow', role);
            role_shadow.setLocalZOrder(-1);
            role.endX = 1334 * (i * 0.5 + 2.2);
            role.speed = roleSpeed[i] + Math.random() * 10;
            role.direction = 'toR';
            role.entry_aim = null;
            role.setName(roleName[i]);
            role.setPosition(rolePos[i]);
            role.setLocalZOrder(roleZOrder[i]);
            if (roleName[i] != 'monkey') {
                role.setAnimation(0, 'huxi', true);
            } else if (roleName[i] == 'monkey') {
                role.setAnimation(0, 'maipiao', true);
                role.setCompleteListener((trackEntry) => {
                    var name = trackEntry.animation ? trackEntry.animation.name : '';
                    if (name == 'maipiao') {
                        var scroll = Global_DP_GameEntry.scroll;
                        // zLog('percent : ', sw / (scroll.getInnerContainerSize().width - sw) * 100);
                        var time = 5;
                        var percent = sw / (scroll.getInnerContainerSize().width - sw) * 100;   // 进场后截掉前面一屏
                        scroll.scrollToPercentHorizontal(percent, time, false);
                        scroll.scheduleOnce(scroll.setAllChildrenOffsetX, time);
                        for (var i = 0; i < roles.length; ++i) {
                            // zLog('role name : ', roles[i].getName());
                            roles[i].setAnimation(0, 'zoulu', true);
                            roles[i].beginInto();
                        }
                    }
                });
            }
            (function (role) {
                var moving_range = sw * 0.60;
                // 开始入场分为两段 先跑一屏宽的距离 再跑到终点（角色活动范围的中间点）
                role.beginInto = function () {
                    // var timeInto = role.moveTo(role.endX);
                    var deltaX1 = sw;     // 跑动相对值
                    var deltaX2 = role.endX - sw - role.x;    // 跑动之后距离终点想点对值
                    var timeInto1 = Math.abs(deltaX1 / (role.speed + 200));
                    var timeInto2 = Math.abs(deltaX2 / role.speed);
                    role.stopAllActions();
                    role.setRotationY(deltaX1 > 0 ? 180 : 0);
                    role.setTimeScale((role.speed + 200) / role.speed);
                    role.setCompleteListener((trackEntry) => {
                        var name = trackEntry.animation ? trackEntry.animation.name : '';
                        if (name == 'huishou') {
                            role.setAnimation(0, 'zoulu', true);
                            if (role.direction == 'toR') {
                                role.moveToR();
                            } else if (role.direction == 'toL') {
                                role.moveToL();
                            }
                        }
                    });
                    role.runAction(cc.sequence(
                        cc.moveBy(timeInto1, deltaX1, 0),
                        cc.callFunc(() => {
                            role.setTimeScale(1);
                            // 给角色添加事件
                            var listener = zNewEventListenerCreate((touch, target) => {
                                // 如果角色有目标
                                if (role.entry_aim) {
                                    // zLog('aim : ', role.entry_aim);
                                    // role.setAnimation(0, '', false);
                                    var cur_percent = self.getScrolledPercentHorizontal();
                                    var aim_percent = role.entry_aim_percent;
                                    var delta_percent = Math.abs(aim_percent - cur_percent);
                                    var scroll_time = delta_percent / 30;
                                    var entry_aim = role.entry_aim;
                                    self.scrollToPercentHorizontal(aim_percent, scroll_time, false);
                                    self.pauseEntry();
                                    self.setTouchEnabled(false);
                                    self.scheduleOnce(() => {
                                        self.intoEntry(entry_aim);
                                    }, scroll_time + 0.001);
                                }
                                // 否则角色没有目标 打声招呼
                                else {
                                    // zLog('hello, I am ', role.getName());
                                    role.stopAllActions();
                                    // role.unscheduleAllCallbacks();
                                    if (role.direction == 'toR') {
                                        role.unschedule(role.moveToL);
                                    } else if (role.direction == 'toL') {
                                        role.unschedule(role.moveToR);
                                    }
                                    role.setAnimation(0, 'huishou', false);
                                    ddSound.stopAll();
                                    ddSound.playEffect('role_i_am_' + role.getName());
                                }
                            }, null, null, null);
                            var roleEventNode = new cc.Node();
                            roleEventNode.setContentSize(cc.size(200, 200));
                            roleEventNode.setAnchorPoint(0.5, 0);
                            role.addChild(roleEventNode);
                            zSetNodeEvent(listener, roleEventNode);
                            // zShowContentSize(roleEventNode);
                        }),
                        cc.moveTo(timeInto2, role.endX, role.y)
                    ));
                    role.scheduleOnce(() => {
                        role.endX -= cc.winSize.width;
                        role.moveToR();
                    }, timeInto1 + timeInto2);
                };
                role.moveToL = function () {
                    var timeL = role.moveTo(role.endX - moving_range);
                    role.direction = 'toL';
                    role.scheduleOnce(role.moveToR, timeL + 0.001);
                    // zLog('timeL : ', timeL.toFixed(2));
                };
                role.moveToR = function () {
                    var timeR = role.moveTo(role.endX + moving_range);
                    role.direction = 'toR';
                    role.scheduleOnce(role.moveToL, timeR + 0.001);
                    // zLog('timeR : ', timeR.toFixed(2));
                };
                role.moveTo = function (endPosX) {
                    var deltaX = endPosX - role.x;
                    var time = Math.abs(deltaX / role.speed);
                    role.stopAllActions();
                    role.setRotationY(deltaX > 0 ? 180 : 0);
                    role.runAction(cc.moveTo(time, endPosX, role.y));
                    return time;
                };
            })(role);
            roles.push(role);

            // zAddTouchLogPosEvent(role);
        }
        // 定时随机找一个角色 添加一个聊天气泡
        var entry_aims = ['whack_a_mole', 'fishing', 'shooting', 'popcorn', 'coin_dozer', 'slot_machine', 'dining_room'];
        var entry_aims_percent = [0, 11, 26, 42, 59, 76, 100];
        this.schedule(() => {
            // var role = roles[0];
            var role = roles[Math.floor(Math.random() * roles.length)];
            role.scheduleOnce(() => {
                // var entry_aims_idx = 3;
                var entry_aims_idx = zGetRandomInter(entry_aims.length);
                var entry_aim = entry_aims[entry_aims_idx];
                var entry_aim_percent = entry_aims_percent[entry_aims_idx];
                var chat_bubble_0 = zNewSpriteCreate(dir + 'role/chat_bubble/', 'bubble_0', role);
                var chat_bubble_1 = zNewSpriteCreate(dir + 'role/chat_bubble/', 'bubble_1', chat_bubble_0);
                var chat_bubble_2 = zNewSpriteCreate(dir + 'role/chat_bubble/', 'bubble_2', chat_bubble_1);
                var chat_bubble_aim = zNewSpriteCreate(dir + 'role/chat_bubble/', entry_aim, chat_bubble_2);
                chat_bubble_0.setPosition(81.97, 190.45);
                chat_bubble_1.setPosition(38.54, 25.21);
                chat_bubble_2.setPosition(107.23, 66.25);
                chat_bubble_aim.setPosition(chat_bubble_2.width / 2, chat_bubble_2.height / 2);
                chat_bubble_aim.setOpacity(0);
                chat_bubble_aim.runAction(cc.fadeIn(0.3));
                role.entry_aim = entry_aim;
                role.entry_aim_percent = entry_aim_percent;
                if (role.direction == 'toR') {
                    role.unschedule(role.moveToL);
                } else if (role.direction == 'toL') {
                    role.unschedule(role.moveToR);
                }
                role.stopAllActions();
                role.setAnimation(0, 'huishou', false);
                ddSound.playEffect('role_want_play_this_' + role.getName());
                // zAddTouchLogPosEvent(chat_bubble_0);
                // zAddTouchLogPosEvent(chat_bubble_1);
                // zAddTouchLogPosEvent(chat_bubble_2);
                // zAddTouchLogPosEvent(chat_bubble_aim);

                // 2秒后聊天气泡自动消失
                chat_bubble_0.scheduleOnce(() => {
                    chat_bubble_0.removeFromParent(true);
                    role.entry_aim = null;
                }, 2);
            }, Math.random() + 0.001);
        }, 8, 65535, 6);
    },
    addBalloon: function () {
        for (var i = 0; i < 5; ++i) {
            var listener = zNewEventListenerCreate((touch, target) => {
                zPauseTargetEvent(target);
                ddSound.playEffect('entry_balloon_bomb');
                target.spine.setAnimation(0, target.clr + 'po', false);
                target.spine.setCompleteListener((trackEntry) => {
                    var name = trackEntry.animation ? trackEntry.animation.name : '';
                    if (name == (target.clr + 'po')) {
                        // target.stopAllActions();
                        target.runAction(cc.callFunc(() => {
                            target.removeFromParent(true);
                        }));
                    }
                })
            }, null, null, null);
            var clr = Global_DP_GameEntry.balloon_name[Math.floor(Math.random() * 3)];
            var balloon = zNewSpriteCreate(Global_DP_GameEntry.dir, 'balloon', this);
            var balloonSpine = zNewSpineAnimationCreate(Global_DP_GameEntry.dir + 'balloon/', 'skeleton', balloon);
            balloonSpine.setAnimation(0, clr, true);
            balloonSpine.setPosition(35.96, -10.51);
            balloon.setPosition(cc.winSize.width / 2 + cc.winSize.width * (zGetOppositeNumber() / 2 + i), -150);
            // balloon.setPosition(Math.random() * (this.getInnerContainerSize().width - cc.winSize.width) + cc.winSize.width, cc.winSize.height / 2);
            balloon.setOpacity(0);
            balloon.setLocalZOrder(5);
            balloon.clr = clr;
            balloon.spine = balloonSpine;
            balloon.runAction(cc.sequence(
                cc.moveTo(Math.random() + 4, balloon.x, cc.winSize.height + 200),
                cc.removeSelf(true)
            ));
            zSetNodeEvent(listener, balloon);
        }

        var random_time = Math.random() * 4 + 8;
        this.scheduleOnce(this.addBalloon, random_time);
        // zAddTouchLogPosEvent(balloon);
        // zAddTouchLogPosEvent(balloonSpine, true);
        // zLog('clr : ', clr);
    },
    addBalloonHot: function () {
        var balloon_hot_y = zNewSpineAnimationCreate(Global_DP_GameEntry.dir + 'balloon_hot/', 'skeleton', this);
        var balloon_hot_b = zNewSpineAnimationCreate(Global_DP_GameEntry.dir + 'balloon_hot/', 'skeleton', this);
        balloon_hot_y.setPosition(2609.30, 575.53);
        balloon_hot_y.setAnimation(0, 'huang', true);
        balloon_hot_b.setPosition(5569.06, 586.55);
        balloon_hot_b.setAnimation(0, 'lan', true);

        // zAddTouchLogPosEvent(balloon_hot_b);
        // zAddTouchLogPosEvent(balloon_hot_y);
    }
});

var DP_GameEntryLayer = cc.Layer.extend({
    has_coin_no_layer: false,
    has_coin_lack_layer: false,
    ctor: function () {
        this._super();
        this.y = Global_DP.sinkY;
        Global_DP_GameEntry.layer = this;
        this.setName('game entry');

        var scrollView = new DP_GameEntryScrollView();
        this.addChild(scrollView);
        this.scrollView = scrollView;

        this.addHomeBtn();
        // this.addMoveBtn();

        // zAddCoinNotEnoughLayer(this);
        Global_DP_GameEntry.coin_box = zAddCoinBox(this);
    },
    onEnter: function () {
        this._super();
        var coin_box = Global_DP_GameEntry.coin_box;
        coin_box.setCoinNumber(zGetLocalCoinNumber());
    },
    addHomeBtn: function () {
        var home_cb = function (touch, target) {
            zPauseTargetEvent(target, true);
            cc.director.popScene();
        };
        var home = zAddButtonBegin(this, Global_DP_Button.dir, 'home', home_cb);
        var pos = this.convertToNodeSpace(cc.p(home.getButtonImage().width / 2 + 20, cc.winSize.height - (home.getButtonImage().height / 2 + 20)));
        home.setPosition(pos);
        this.home_btn = home;
    },
    hideHomeBtn: function () {
        this.home_btn.setVisible(false);
    },
    showHomeBtn: function () {
        this.home_btn.setVisible(true);
    },
    addMoveBtn: function () {
        var self = this;
        var dPercent = 100 / 3;
        var move_btn_L = zNewSpriteCreate(Global_DP_Button.dir, 'left', self);
        var move_btn_R = zNewSpriteCreate(Global_DP_Button.dir, 'left', self);
        var listener = zNewEventListenerCreate(function (touch, target) {
            target.setScale(1.1);
        }, null, function (touch, target) {
            target.setScale(1);
            var now_time = new Date();
            if (Math.abs(now_time - target.last_time) < 1000) {
                return;
            }
            target.last_time = now_time;
            var scrollView = self.scrollView;
            var cPercent = scrollView.getScrolledPercentHorizontal();
            // zLog('cPercent : ', cPercent);
            if (target.getName() == 'toL') {
                // zLog('toL');
                // zLog('nPercent : ', cPercent - dPercent >= 0 ? cPercent - dPercent : 0);
                if (cPercent <= 0.01) {
                    move_btn_L.setScale(0);
                    move_btn_R.setScale(1);
                    return;
                }
                move_btn_R.setScale(1);
                scrollView.scrollToPercentHorizontal(cPercent - dPercent > 0 ? cPercent - dPercent : 0, cPercent > dPercent ? 1 : (cPercent - 0) / dPercent, false);
                if ((cPercent - dPercent > 0 ? cPercent - dPercent : 0) <= 0.01) {
                    move_btn_L.setScale(0);
                }
            } else if (target.getName() == 'toR') {
                // zLog('toR');
                // zLog('nPercent : ', cPercent + dPercent < 100 ? cPercent + dPercent : 100);
                if (cPercent >= 99.99) {
                    move_btn_R.setScale(0);
                    move_btn_L.setScale(1);
                    return;
                }
                move_btn_L.setScale(1);
                scrollView.scrollToPercentHorizontal((cPercent + dPercent < 100 ? cPercent + dPercent : 100), cPercent < 100 - dPercent ? 1 : (100 - cPercent) / dPercent, false);
                if ((cPercent + dPercent < 100 ? cPercent + dPercent : 100) >= 99.99) {
                    move_btn_R.setScale(0);
                }
            }
            // zLog('--------');
        }, function (touch, target) {
            target.setScale(1);
        });
        move_btn_L.setName('toL');
        move_btn_L.setPosition(150, 750 / 2);
        move_btn_L.last_time = new Date();
        move_btn_R.setName('toR');
        move_btn_R.setPosition(cc.winSize.width - 150, 750 / 2);
        move_btn_R.last_time = new Date();
        move_btn_R.setFlippedX(true);
        zSetNodeEvent(listener, move_btn_L);
        zSetNodeEvent(listener.clone(), move_btn_R);

        this.move_btn_L = move_btn_L;
        this.move_btn_R = move_btn_R;
    }
});

var DP_GameEntryScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new DP_GameEntryLayer();
        this.addChild(layer);

        zAddKeyboardBackEventCreate(this);
    },
    cleanup: function () {
        this._super();
        cc.spriteFrameCache.removeSpriteFrames();
        cc.textureCache.removeAllTextures();
        cc.sys.garbageCollect();
    }
});
