var Global_DP_Shooting = null;

function init_Global_DP_Shooting() {
    Global_DP_Shooting = {
        dir: 'res/game/shooting/',
        wavePos: [cc.p(0, 591.26), cc.p(0, 375.00), cc.p(0, 200.59)],
        waveZOrder: [10, 20, 30],
        layer: null,
        fishManager: null,
        coinBox: null,
        timeClock: null
    };
}

var DP_Shooting_FishManager = cc.Node.extend({
    gameOver: false,
    score: 0,
    fishSpeed: 200,
    isDestroy: false,
    difficulty: 1,
    fishName: ['cheng', 'hong', 'huang', 'lan', 'lv', 'zhangyu'],
    fishSize: [cc.size(142, 160), cc.size(204, 180), cc.size(165, 161), cc.size(211, 195), cc.size(170, 160), cc.size(193, 247)],
    ctor: function () {
        this._super();

    },
    randomFish: function () {
        if (this.gameOver) {
            // 游戏结束 不再生成鱼
            return;
        }
        var layer = Global_DP_Shooting.layer;
        // 随机一个方向
        var direction = Math.round(Math.random()) ? 'toL' : 'toR';

        // 随机一条鱼
        var idt = Math.floor(Math.random() * this.fishName.length);
        var name = this.fishName[idt];
        var fishSize = this.fishSize[idt];
        var aniName = name + ((name == 'zhangyu') ? '1' : 'you');
        var dir = Global_DP_Shooting.dir + 'spine/' + ((name != 'lv' && name != 'zhangyu') ? '' : name + '/');
        // 随机一行
        var row = Math.floor(Math.random() * 3);
        var offsetY = ((name == 'zhangyu') ? 50 : 0) + ((name == 'lv') ? -20 : 0);
        var startX = ((direction == 'toR') ? 0 : cc.winSize.width) + fishSize.width / 2 - layer.x;
        var endX = fishSize.width - startX;

        var fishNode = new cc.Node();
        layer.addChild(fishNode);
        fishNode.setName(name);
        fishNode.setContentSize(fishSize);
        fishNode.setPosition(startX, Global_DP_Shooting.wavePos[row].y + 50 + offsetY);
        fishNode.setLocalZOrder(Global_DP_Shooting.waveZOrder[row] - 5);
        fishNode.setAnchorPoint(0.5, 0.5);
        fishNode.hitCount = 0;
        // zShowContentSize(fishNode, fishNode.getContentSize());

        var fishSpine = zNewSpineAnimationCreate(dir, 'skeleton', fishNode);
        fishSpine.setPosition(fishSize.width / 2, fishSize.height / 2);
        fishSpine.setAnimation(0, aniName, true);
        fishSpine.setRotationY(direction == 'toR' ? (name == 'zhangyu' ? 0 : 180) : 0);
        // fishSpine.setTimeScale(0.5);
        fishNode.spine = fishSpine;

        var listener = zNewEventListenerCreate(function (touch, target) {
            var coinBox = Global_DP_Shooting.coinBox;
            // zLog('fish name : ', target.getName());
            // 章鱼被点击
            /*var pos = target.getPosition();
            var laser = zNewSpriteCreate(Global_TimeClock.dir, 'bar_time_much', layer);
            laser.setScale(0, 0.5);
            laser.setLocalZOrder(40);
            laser.setRotation(180 - Math.acos(pos.x / cc.pLength(pos)) / Math.PI * 180);
            laser.runAction(cc.sequence(
                cc.spawn(cc.sequence(cc.scaleTo(0.02, 0.3, 0.5), cc.delayTime(0.1), cc.scaleTo(0.02, 0, 0.5)), cc.moveTo(0.14, pos)),
                cc.removeSelf(true)
            ));*/
            ddSound.playEffect('game_shooting_shoot');
            var p1 = cc.pAdd(zGetNodePosition(coinBox, zGetWorldPosition(target)), cc.p(0, 50));
            if (target.getName() == 'zhangyu') {
                target.hitCount++;
                // zLog('hit count : ', target.hitCount);
                if (target.hitCount < 3) {
                    target.spine.setAnimation(0, target.getName() + (target.hitCount + 1), true);
                    target.spine.runAction(cc.sequence(
                        cc.scaleTo(0.1, 1.2),
                        cc.scaleTo(0.1, 1)
                    ));
                    // coinBox.runGetCoinAction(p1, 1);
                    return;
                } else {
                    target.spine.setAnimation(0, target.getName() + 'jing', true);
                    // coinBox.runGetCoinAction(p1, 2);
                    coinBox.runGetCoinAction2(p1, 4);
                }
            }
            // 普通鱼被点击
            else {
                target.spine.setAnimation(0, target.getName() + 'jing', false);
                coinBox.runGetCoinAction(p1, 1);
            }
            zPauseTargetEvent(target);
            target.stopAllActions();
            target.spine.runAction(cc.sequence(
                cc.scaleTo(0.1, 1.2),
                cc.scaleTo(0.1, 1)
            ));
            target.scheduleOnce(function () {
                target.removeFromParent(true);
            }, 0.5);
        }, null, null, null);
        // zSetSpriteEvent(listener, fish);
        // this.moveFish(fish, endX);
        zSetNodeEvent(listener, fishNode);
        this.moveFish(fishNode, endX);

        this.scheduleOnce(this.randomFish, Math.random() + 1 - this.difficulty * 0.1);
    },
    moveFish: function (fish, endX) {
        fish.runAction(cc.sequence(
            cc.moveTo(cc.winSize.width / (Global_DP_Shooting.fishManager.fishSpeed + (0.5 + Math.random() / 2) * 50 * this.difficulty), endX, fish.y),
            cc.removeSelf(true)
        ));
    }
});

var DP_ShootingLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        init_Global_DP_Shooting();
        this.x = cc.winSize.width / 2;
        this.y = Global_DP.sinkY;
        Global_DP_Shooting.layer = this;

        var dir = Global_DP_Shooting.dir;
        var arrName = ['bg_hd', 'wave', 'wave', 'wave'];
        var res = zAddRes(dir, arrName, this);
        var bg_hd = res[0];
        bg_hd.setAnchorPoint(0.5, 0);
        for (var i = 0; i < 3; ++i) {
            var wave = res[i + 1];
            wave.setPosition(Global_DP_Shooting.wavePos[i]);
            wave.setLocalZOrder(Global_DP_Shooting.waveZOrder[i]);
            // zAddTouchLogPosEvent(wave);
        }
        this.addBubble();
        this.addFishManager();
        this.addCoinBox();
        this.addTimeClock();
        this.addBackBtn();
    },
    onEnter: function () {
        this._super();
        // this.count_down.count();
        zPauseTargetEvent(this, true);
        this.countDown = function () {
            this.count_down.count();
            zResumeTargetEvent(this, true);
            var coinBox = Global_DP_Shooting.coinBox;
            coinBox.setCoinNumber(zGetLocalCoinNumber());
        };
        zAddInsertCoinsLayer(this, this.countDown);
    },
    cleanup: function () {
        this._super();
    },
    addBubble: function () {
        var pX = [];
        for (var i = 0; i < 4; ++i) {
            pX.push((i - (4 - 1) / 2) * cc.winSize.width / 4 * 0.8 + cc.winSize.width * 0.05);
        }
        var bubble_L = zNewSpineAnimationCreate(Global_DP_Shooting.dir + 'spine_bubble/', 'skeleton', this);
        bubble_L.rise = function () {
            bubble_L.scheduleOnce(() => {
                var scale = 1 + zGetOppositeNumber() * 0.3;
                bubble_L.setScale(scale);
                bubble_L.setTimeScale(1 / scale + 0.4);
                bubble_L.setAnimation(0, 'qipao', false);
                bubble_L.x = pX[Math.floor(Math.random() * 2)];
            }, Math.random());
        };
        bubble_L.setCompleteListener((trackEntry) => {
            var aniName = trackEntry.animation ? trackEntry.animation.name : '';
            if (aniName == 'qipao') {
                bubble_L.rise();
            }
        });
        bubble_L.rise();

        var bubble_R = zNewSpineAnimationCreate(Global_DP_Shooting.dir + 'spine_bubble/', 'skeleton', this);
        bubble_R.rise = function () {
            bubble_R.scheduleOnce(() => {
                var scale = 1 + zGetOppositeNumber() * 0.2;
                bubble_R.setScale(scale);
                bubble_R.setTimeScale(1 / scale + 0.2);
                bubble_R.setAnimation(0, 'qipao', false);
                bubble_R.x = pX[Math.floor(Math.random() * 2) + 2];
            }, Math.random() * 3);
        };
        bubble_R.setCompleteListener((trackEntry) => {
            var aniName = trackEntry.animation ? trackEntry.animation.name : '';
            if (aniName == 'qipao') {
                bubble_R.rise();
            }
        });
        bubble_R.rise();
    },
    addFishManager: function () {
        var fishManager = new DP_Shooting_FishManager();
        this.addChild(fishManager);
        Global_DP_Shooting.fishManager = fishManager;
    },
    addCoinBox: function () {
        var coinBox = zAddCoinBox(this);
        coinBox.addScore = function (score) {
            var fishManager = Global_DP_Shooting.fishManager;
            if (fishManager.gameOver) {
                return;
            }
            coinBox.setCoinNumber(coinBox.getCoinNumber() + score);
            fishManager.score += score;
            if (fishManager.score >= (fishManager.difficulty * fishManager.difficulty) * 5) {
                var timeClock = Global_DP_Fishing.timeClock;
                fishManager.difficulty += 1;
                timeClock.rewardTime(5);
                // timeClock.setCurTime(timeClock.getCurTime() + 5);
                // zLog('difficulty : ', fishManager.difficulty);
            }
            // zLog('score : ', Global_DP_Shooting.fishManager.score, ', difficulty : ', fishManager.difficulty);
        };
        Global_DP_Shooting.coinBox = coinBox;
    },
    addBackBtn: function () {
        var backBtn = zAddBackButtonBegin(this);
        backBtn.setLocalZOrder(100);
    },
    addTimeClock: function () {
        var timeTotal = 60;
        var self = this;
        var time_out_cb = function () {
            // zLog('time out');
            var fishManager = Global_DP_Shooting.fishManager;
            fishManager.gameOver = true;
            zPauseTargetEvent(self, true);
            zAddAwardCoinLayer(self, fishManager.score);
            umengEvent('GAME_SRC_DONE', 'shooting');
            ddSound.stopAll();
            ddSound.playEffect('game_shooting_click_fish');
        };
        var timeClock = zAddMyTimeClock(this, timeTotal, time_out_cb);
        timeClock.setLocalZOrder(50);
        Global_DP_Fishing.timeClock = timeClock;

        var count_down_0_cb = function () {
            timeClock.startTiming();
            var fishManager = Global_DP_Shooting.fishManager;
            fishManager.randomFish();
        };
        this.count_down = zAddCountDown(this, 1, 3, count_down_0_cb);
    }
});

var DP_ShootingScene = cc.Scene.extend({
    ctor: function () {
        this._super();

        var layer = new DP_ShootingLayer();
        this.addChild(layer);

        zAddKeyboardBackEventCreate(this);
    }
});