Global_DP_GetAwardCoin = {
    dir: 'res/win_coin/'
};

var DP_GetAwardCoinLayer = cc.Layer.extend({
    ctor: function () {
        this._super();

        var bgColor = new cc.LayerColor(cc.color(0, 0, 0, 175), cc.winSize.width, cc.winSize.height);
        var bg_listener = zNewEventListenerCreate(null, null, function (touch, target) {
            cc.director.popScene();
        }, null);
        zSetNodeEvent(bg_listener, bgColor);
        this.addChild(bgColor);

        var swallowNode = new cc.Node();
        swallowNode.setContentSize(cc.size(500, 400));
        swallowNode.setAnchorPoint(0.5, 0.5);
        swallowNode.setPosition(cc.winSize.width / 2, cc.winSize.height / 2);
        var swallow_listener = zNewEventListenerCreate(null, null, null, null);
        zSetNodeEvent(swallow_listener, swallowNode);
        this.addChild(swallowNode);
        // zShowContentSize(swallowNode);
        //
        var dir = Global_DP_GetAwardCoin.dir;
        var size = cc.winSize;
        // var total_coin_box = zNewSpriteCreate(dir, 'total_coin_box', this);
        // var light = zNewSpriteCreate(dir, 'light', total_coin_box);
        var coin = zNewSpriteCreate(dir, 'coin', this);
        var label = zNewLabelCreate('0', null, 70, this);
        //
        // total_coin_box.setPosition(cc.winSize.width / 2, cc.winSize.height / 2);
        // light.setPosition(total_coin_box.width / 2, total_coin_box.height / 2);
        // light.setLocalZOrder(-1);
        coin.setPosition(size.width / 2 - 80, size.height / 2);
        coin.setLocalZOrder(5);
        label.setPosition(size.width / 2 + 80, size.height / 2);
        label.setFontFillColor(cc.color(255, 201, 36));
        label.setLocalZOrder(5);
        this.label = label;

        // var spine = sp.SkeletonAnimation.createWithJsonFile(Global_DP_GetAwardCoin.dir + 'spine/');
        var spine = zNewSpineAnimationCreate(dir + 'spine/', 'skeleton', this);
        spine.setPosition(cc.winSize.width / 2, cc.winSize.height / 2);
        spine.setAnimation(0, 'shanguang', true);
        // spine.setTimeScale(0.5);

        zAddBackButtonBegin(this);
    },
    setCoinLabelText: function (text) {
        this.label.setString(text);
    }
});

function zAddAwardCoinLayer(parent, coin_total) {
    var awardLayer = new DP_GetAwardCoinLayer();
    parent.addChild(awardLayer);
    awardLayer.setLocalZOrder(65535);
    // zLogPos(parent.convertToNodeSpace(cc.p(0, 0)));
    awardLayer.setPosition(parent.convertToNodeSpace(cc.p(0, 0)));
    awardLayer.setCoinLabelText(coin_total);
    ddSound.stopAll();
    if (coin_total < 10) {
        ddSound.playEffect('little_friend_come_on');
    } else {
        ddSound.playEffect('little_friend_great');
    }
}

//
// 金币框

var zCoinBox = cc.Node.extend({
    ctor: function () {
        this._super();

        this.addLabel();
    },
    addLabel: function () {
        var label = new cc.LabelTTF('0', "Arial", 50);
        label.setPosition(55.75, -3.79);
        this.addChild(label, 10);
        this.label = label;

        // zAddTouchLogPosEvent(label);
        // zShowContentSize(label, label.getContentSize());
    },
    setCoinNumber: function (number) {
        this.label.setString(number > 9999 ? 9999 : number);
        zSetLocalCoinNumber(number);
    },
    setCoinNumberNotSave: function (number) {
        this.label.setString(number > 9999 ? 9999 : number);
    },
    getCoinNumber: function () {
        // zLog('number : ', Number(this.label.getString()));
        return Number(this.label.getString());
    },
    setCoinBoxImage: function (dir, name) {
        // zLog(dir, name, suffixPNG);
        this.image = zNewSpriteCreate(dir, name, this);
    },
    getCoinBoxImage: function () {
        return this.image;
    },
    runGetCoinAction: function (p1, score) {
        var coinBox = this;
        var coin = zNewSpriteCreate(Global_DP_GetAwardCoin.dir, 'coin', coinBox);
        var p2 = cc.p(-70, 0);
        var time = cc.pDistance(p1, p2) / cc.winSize.width;
        coin.setPosition(p1);
        coin.runAction(cc.sequence(
            cc.delayTime(0.2),
            // cc.moveTo(time, p2)
            zGetBezierTo(time, p1, p2),
            cc.callFunc(() => {
                zSetSpriteTexture(Global_DP_GetAwardCoin.dir, 'coin_light', coin);
                ddSound.playEffect('coin_get');
                coinBox.addScore(score);
            }),
            cc.fadeOut(0.2),
            cc.removeSelf(true)
        ));
    },
    runGetCoinAction2: function (p1, score) {
        var self = this;
        for (var i = 0; i < score; ++i) {
            (function (idx) {
                self.scheduleOnce(() => {
                    self.runGetCoinAction(p1, 1);
                }, 0.1 * idx + 0.1);
            })(i)
        }
    }
});

function zAddCoinBox(parent) {
    var coinBox = new zCoinBox();
    parent.addChild(coinBox);
    coinBox.setCoinBoxImage(Global_DP_Button.dir, 'coin_box');
    coinBox.setLocalZOrder(100);
    var coinBoxImage = coinBox.getCoinBoxImage();
    var worldPos = cc.p(cc.winSize.width - coinBoxImage.width / 2, cc.winSize.height - coinBoxImage.height / 2);
    coinBox.setPosition(parent.convertToNodeSpace(worldPos));
    coinBox.setCoinNumber(zGetLocalCoinNumber());
    return coinBox;
}